﻿Imports System.Threading.Thread
Imports System.Threading.Tasks

Public Class Form1

    Private scheduler As TaskScheduler = Nothing

    Sub New()
        InitializeComponent()

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.scheduler = TaskScheduler.FromCurrentSynchronizationContext()
        'atribui os valores máximos para o intervalo númerico
        Me.nudSuperior.Maximum = Integer.MaxValue
        Me.nudInferior.Maximum = Integer.MaxValue
    End Sub

    Private Function getPrimosNoIntervalo(valorInicialInclusivo As Integer, valorFinalExclusivo As Integer) As IEnumerable(Of Integer)
        'força um atraso de 2 segundos
        Sleep(TimeSpan.FromMilliseconds(1000))
        'retorna quantos números primos existe no intervalo
        Return getTodosNumerosPrimos(Enumerable.Range(valorInicialInclusivo, (valorFinalExclusivo - valorInicialInclusivo)))
    End Function

    Private Function getTodosNumerosPrimos(numeros As IEnumerable(Of Integer)) As IEnumerable(Of Integer)
        'calcula a quantidade de número primos 
        Return From n In numeros Where (Not (n <= 1) AndAlso Enumerable.Range(2, CInt(Math.Sqrt(If(n = 2, 0, n)))).All(Function(i) n Mod i > 0)) Select n
    End Function
    Private Sub nudInferior_Validating(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles nudInferior.Validating
        'valida a entrada do usuário
        If Me.nudInferior.Value > Me.nudSuperior.Value Then
            Me.nudInferior.Value = Me.nudSuperior.Value
        End If
    End Sub
    Private Sub btnCalcular_Click(sender As Object, e As EventArgs) Handles btnCalcular.Click
        'exibe a quantidade de número primos
        Me.txtPrimos.Text += Me.getPrimosNoIntervalo(Integer.Parse(Me.nudInferior.Value.ToString()), Integer.Parse(Me.nudSuperior.Value.ToString())).Count().ToString() + Environment.NewLine
    End Sub

    Private Sub btnCalcularTasks_Click(sender As Object, e As EventArgs) Handles btnCalcularTasks.Click

        'para evitar o acesso cross thread dos controles vamos armazenar os valores em variáveis
        Dim inferior As Integer = Integer.Parse(Me.nudInferior.Value.ToString())
        Dim superior As Integer = Integer.Parse(Me.nudSuperior.Value.ToString())

        'inicia uma nova task, e então exibe o resultado no textbox
        Task.Factory.StartNew(Of Integer)(Function() Me.getPrimosNoIntervalo(inferior, superior).Count()).
                 ContinueWith(Function(i) (txtPrimos.Text = i.Result.ToString() + Environment.NewLine), Me.scheduler)

    End Sub
End Class
